Subject: Re: Rebase a whole tree from one commit to another?

From: Andreas Ericsson <[email-masked]>
Date: Sat, 16 May 2009 09:35:33 +0200

Dirk Süsserott wrote:
> Hi alltogether.
> 
> Let's say I have the following history:
> 
>     | | | | branch-c
>     | | | |
>     | | |/  branch-b
>     | | |
>     | |/    branch-a
>     | |
>     |/
>     | master
> 
> Now I checkout master, do some changes, and commit them to the master 
> branch. Let's call that new-master:
> 
>    | new-master
>    | | | | | branch-c
>    | | | | |
>    | | | |/  branch-b
>    | | | |
>    | | |/    branch-a
>    | | |
>    | |/
>     \| master
> 
> I want to rebase my branches a, b, c to the new master. The clumsy way 
> would be:
> 
>     git rebase new-master branch-a
>     git rebase branch-a   branch-b
>     git rebase branch-b   branch-c
> 
> The question is: Is there a way to rebase the whole tree (master -> 
> branch-a -> branch-b -> branch-c) from master to new-master with a 
> single command?
> 

No. You could merge all the branches that forked from master, rebase
the merged branch to new-master and then undo the merge-commit though,
but that would still mean three commands (and most likely some
conflict resolution). Assuming you have (a lot) more than three
branches, this might be a way forward for you.

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231

Register now for Nordic Meet on Nagios, June 3-4 in Stockholm
 http://nordicmeetonnagios.op5.org/

Considering the successes of the wars on alcohol, poverty, drugs and
terror, I think we should give some serious thought to declaring war
on peace.